diff --git a/django/http/__init__.py b/django/http/__init__.py
index e585a71..7c096fc 100644
--- a/django/http/__init__.py
+++ b/django/http/__init__.py
@@ -1,5 +1,7 @@
+import datetime
 import os
 import re
+import time
 from Cookie import BaseCookie, SimpleCookie, CookieError
 from pprint import pformat
 from urllib import urlencode
@@ -12,6 +14,7 @@ except ImportError:
 
 from django.utils.datastructures import MultiValueDict, ImmutableList
 from django.utils.encoding import smart_str, iri_to_uri, force_unicode
+from django.utils.http import cookie_date
 from django.http.multipartparser import MultiPartParser
 from django.conf import settings
 from django.core.files import uploadhandler
@@ -373,11 +376,27 @@ class HttpResponse(object):
 
     def set_cookie(self, key, value='', max_age=None, expires=None, path='/',
                    domain=None, secure=False):
+        """
+        Sets a cookie.
+
+        ``expires`` can be a string in the correct format or a datetime object
+        (either datetime.datetime or datetime.timedelta) in UTC. If ``expires``
+        is a datetime object then ``max_age`` will be calculated.
+        """
         self.cookies[key] = value
-        if max_age is not None:
-            self.cookies[key]['max-age'] = max_age
         if expires is not None:
+            if isinstance(expires, (datetime.datetime, datetime.timedelta)):
+                if isinstance(expires, datetime.datetime):
+                    expires = expires - expires.utcnow()
+                    # Add one second so the date matches exactly (a fraction of
+                    # time gets lost between converting to a timedelta and
+                    # then the date string).
+                    expires = expires + datetime.timedelta(seconds=1)
+                max_age = max(0, expires.days * 86400 + expires.seconds)
+                expires = cookie_date(time.time() + max_age)
             self.cookies[key]['expires'] = expires
+        if max_age is not None:
+            self.cookies[key]['max-age'] = max_age
         if path is not None:
             self.cookies[key]['path'] = path
         if domain is not None:
diff --git a/docs/ref/request-response.txt b/docs/ref/request-response.txt
index bf984f4..400bf0b 100644
--- a/docs/ref/request-response.txt
+++ b/docs/ref/request-response.txt
@@ -512,10 +512,13 @@ Methods
     Sets a cookie. The parameters are the same as in the `cookie Morsel`_
     object in the Python standard library.
 
+        * ``expires`` should either be a string in the format
+          ``"Wdy, DD-Mon-YY HH:MM:SS GMT"`` or a ``datetime`` object
+          (either ``datetime.datetime`` in UTC or ``datetime.timedelta``).
+          If ``expires`` is either type of ``datetime`` object, the ``max_age``
+          will be calculated.
         * ``max_age`` should be a number of seconds, or ``None`` (default) if
           the cookie should last only as long as the client's browser session.
-        * ``expires`` should be a string in the format
-          ``"Wdy, DD-Mon-YY HH:MM:SS GMT"``.
         * Use ``domain`` if you want to set a cross-domain cookie. For example,
           ``domain=".lawrence.com"`` will set a cookie that is readable by
           the domains www.lawrence.com, blogs.lawrence.com and
diff --git a/tests/regressiontests/requests/tests.py b/tests/regressiontests/requests/tests.py
index 1615a73..f6c2c6d 100644
--- a/tests/regressiontests/requests/tests.py
+++ b/tests/regressiontests/requests/tests.py
@@ -1,5 +1,5 @@
 """
->>> from django.http import HttpRequest
+>>> from django.http import HttpRequest, HttpResponse
 >>> print repr(HttpRequest())
 <HttpRequest
 GET:{},
@@ -44,4 +44,23 @@ https://www.example.com/asdf
 >>> request.path = ''
 >>> print request.build_absolute_uri(location="/path/with:colons")
 http://www.example.com/path/with:colons
+
+
+# Test cookie datetime expiration logic
+>>> from datetime import datetime, timedelta
+>>> delta = timedelta(seconds=10)
+>>> response = HttpResponse()
+>>> response.set_cookie('datetime', expires=datetime.utcnow()+delta)
+>>> response.set_cookie('delta', expires=delta)
+>>> datetime_cookie = response.cookies['datetime']
+>>> timedelta_cookie = response.cookies['datetime']
+>>> datetime_cookie['max-age']
+10
+>>> datetime_cookie['max-age'] == timedelta_cookie['max-age']
+True
+>>> datetime_cookie['expires'] == timedelta_cookie['expires']
+True
+>>> response.set_cookie('datetime', expires=datetime(2028, 1, 1, 4, 5, 6))
+>>> response.cookies['datetime']['expires']
+'Sat, 01-Jan-2028 04:05:06 GMT'
 """