Index: django/django/contrib/formtools/tests.py
===================================================================
--- django/django/contrib/formtools/tests.py	(revision 7999)
+++ django/django/contrib/formtools/tests.py	(working copy)
@@ -1,7 +1,6 @@
 from django import forms
 from django.contrib.formtools import preview
 from django import http
-from django.conf import settings
 from django.test import TestCase
 
 success_string = "Done was called!"
Index: django/django/contrib/syndication/feeds.py
===================================================================
--- django/django/contrib/syndication/feeds.py	(revision 7999)
+++ django/django/contrib/syndication/feeds.py	(working copy)
@@ -1,5 +1,5 @@
 from django.core.exceptions import ImproperlyConfigured, ObjectDoesNotExist
-from django.template import Context, loader, Template, TemplateDoesNotExist
+from django.template import loader, Template, TemplateDoesNotExist
 from django.contrib.sites.models import Site, RequestSite
 from django.utils import feedgenerator
 from django.utils.encoding import smart_unicode, iri_to_uri
Index: django/django/contrib/admin/options.py
===================================================================
--- django/django/contrib/admin/options.py	(revision 7999)
+++ django/django/contrib/admin/options.py	(working copy)
@@ -1,4 +1,4 @@
-from django import oldforms, template
+from django import template
 from django import forms
 from django.forms.formsets import all_valid
 from django.forms.models import modelform_factory, inlineformset_factory
Index: django/django/contrib/admin/views/main.py
===================================================================
--- django/django/contrib/admin/views/main.py	(revision 7999)
+++ django/django/contrib/admin/views/main.py	(working copy)
@@ -6,7 +6,6 @@
 from django.db.models.query import QuerySet
 from django.utils.encoding import force_unicode, smart_str
 from django.utils.translation import ugettext
-from django.utils.safestring import mark_safe
 from django.utils.http import urlencode
 import operator
 
Index: django/django/contrib/admin/widgets.py
===================================================================
--- django/django/contrib/admin/widgets.py	(revision 7999)
+++ django/django/contrib/admin/widgets.py	(working copy)
@@ -7,8 +7,7 @@
 from django import forms
 from django.forms.widgets import RadioFieldRenderer
 from django.forms.util import flatatt
-from django.utils.datastructures import MultiValueDict
-from django.utils.text import capfirst, truncate_words
+from django.utils.text import truncate_words
 from django.utils.translation import ugettext as _
 from django.utils.safestring import mark_safe
 from django.utils.encoding import force_unicode
Index: django/django/contrib/databrowse/plugins/calendars.py
===================================================================
--- django/django/contrib/databrowse/plugins/calendars.py	(revision 7999)
+++ django/django/contrib/databrowse/plugins/calendars.py	(working copy)
@@ -4,7 +4,6 @@
 from django.contrib.databrowse.sites import DatabrowsePlugin
 from django.shortcuts import render_to_response
 from django.utils.text import capfirst
-from django.utils.translation import get_date_formats
 from django.utils.encoding import force_unicode
 from django.utils.safestring import mark_safe
 from django.views.generic import date_based
Index: django/django/contrib/databrowse/plugins/fieldchoices.py
===================================================================
--- django/django/contrib/databrowse/plugins/fieldchoices.py	(revision 7999)
+++ django/django/contrib/databrowse/plugins/fieldchoices.py	(working copy)
@@ -6,7 +6,6 @@
 from django.utils.text import capfirst
 from django.utils.encoding import smart_str, force_unicode
 from django.utils.safestring import mark_safe
-from django.views.generic import date_based
 import urllib
 
 class FieldChoicePlugin(DatabrowsePlugin):
Index: django/django/contrib/databrowse/views.py
===================================================================
--- django/django/contrib/databrowse/views.py	(revision 7999)
+++ django/django/contrib/databrowse/views.py	(working copy)
@@ -1,7 +1,5 @@
-from django.db.models import FieldDoesNotExist, DateTimeField
 from django.http import Http404
 from django.shortcuts import render_to_response
-from django.contrib.databrowse.datastructures import EasyModel, EasyChoice
 
 ###########
 # CHOICES #
Index: django/django/contrib/databrowse/sites.py
===================================================================
--- django/django/contrib/databrowse/sites.py	(revision 7999)
+++ django/django/contrib/databrowse/sites.py	(working copy)
@@ -1,6 +1,6 @@
 from django import http
 from django.db import models
-from django.contrib.databrowse.datastructures import EasyModel, EasyChoice
+from django.contrib.databrowse.datastructures import EasyModel
 from django.shortcuts import render_to_response
 from django.utils.safestring import mark_safe
 
Index: django/django/contrib/auth/admin.py
===================================================================
--- django/django/contrib/auth/admin.py	(revision 7999)
+++ django/django/contrib/auth/admin.py	(working copy)
@@ -1,6 +1,6 @@
 from django.contrib.auth.models import User, Group
 from django.core.exceptions import PermissionDenied
-from django import oldforms, template
+from django import template
 from django.shortcuts import render_to_response
 from django.http import HttpResponseRedirect
 from django.utils.translation import ugettext, ugettext_lazy as _
Index: django/django/contrib/auth/management/commands/createsuperuser.py
===================================================================
--- django/django/contrib/auth/management/commands/createsuperuser.py	(revision 7999)
+++ django/django/contrib/auth/management/commands/createsuperuser.py	(working copy)
@@ -7,7 +7,7 @@
 import re
 import sys
 from optparse import make_option
-from django.contrib.auth.models import User, UNUSABLE_PASSWORD
+from django.contrib.auth.models import User
 from django.core import validators
 from django.core.management.base import BaseCommand, CommandError
 
Index: django/django/contrib/auth/decorators.py
===================================================================
--- django/django/contrib/auth/decorators.py	(revision 7999)
+++ django/django/contrib/auth/decorators.py	(working copy)
@@ -1,7 +1,7 @@
 try:
     from functools import wraps, update_wrapper
 except ImportError:
-    from django.utils.functional import wraps, update_wrapper  # Python 2.3, 2.4 fallback.
+    from django.utils.functional import update_wrapper  # Python 2.3, 2.4 fallback.
 
 from django.contrib.auth import REDIRECT_FIELD_NAME
 from django.http import HttpResponseRedirect
Index: django/django/contrib/auth/forms.py
===================================================================
--- django/django/contrib/auth/forms.py	(revision 7999)
+++ django/django/contrib/auth/forms.py	(working copy)
@@ -2,7 +2,6 @@
 from django.contrib.auth import authenticate
 from django.contrib.sites.models import Site
 from django.template import Context, loader
-from django.core import validators
 from django import forms
 from django.utils.translation import ugettext_lazy as _
 
Index: django/django/contrib/admindocs/views.py
===================================================================
--- django/django/contrib/admindocs/views.py	(revision 7999)
+++ django/django/contrib/admindocs/views.py	(working copy)
@@ -5,7 +5,7 @@
 from django.db import models
 from django.shortcuts import render_to_response
 from django.core.exceptions import ImproperlyConfigured, ViewDoesNotExist
-from django.http import Http404, get_host
+from django.http import Http404
 from django.core import urlresolvers
 from django.contrib.admindocs import utils
 from django.contrib.sites.models import Site
Index: django/django/contrib/sessions/backends/cache.py
===================================================================
--- django/django/contrib/sessions/backends/cache.py	(revision 7999)
+++ django/django/contrib/sessions/backends/cache.py	(working copy)
@@ -1,4 +1,3 @@
-from django.conf import settings
 from django.contrib.sessions.backends.base import SessionBase
 from django.core.cache import cache
 
Index: django/django/contrib/sessions/backends/db.py
===================================================================
--- django/django/contrib/sessions/backends/db.py	(revision 7999)
+++ django/django/contrib/sessions/backends/db.py	(working copy)
@@ -1,6 +1,5 @@
 import datetime
 
-from django.conf import settings
 from django.contrib.sessions.models import Session
 from django.contrib.sessions.backends.base import SessionBase
 from django.core.exceptions import SuspiciousOperation