Index: django/django/db/models/sql/query.py
===================================================================
--- django/django/db/models/sql/query.py	(revision 7999)
+++ django/django/db/models/sql/query.py	(working copy)
@@ -7,7 +7,6 @@
 all about the internals of models in order to get the information it needs.
 """
 
-import datetime
 from copy import deepcopy
 
 from django.utils.tree import Node
Index: django/django/db/models/base.py
===================================================================
--- django/django/db/models/base.py	(revision 7999)
+++ django/django/db/models/base.py	(working copy)
@@ -12,7 +12,7 @@
 import django.db.models.manager         # Ditto.
 from django.core import validators
 from django.core.exceptions import ObjectDoesNotExist, MultipleObjectsReturned, FieldError
-from django.db.models.fields import AutoField, ImageField, FieldDoesNotExist
+from django.db.models.fields import AutoField, ImageField
 from django.db.models.fields.related import OneToOneRel, ManyToOneRel, OneToOneField
 from django.db.models.query import delete_objects, Q, CollectedObjects
 from django.db.models.options import Options
@@ -20,7 +20,6 @@
 from django.db.models import signals
 from django.db.models.loading import register_models, get_model
 from django.dispatch import dispatcher
-from django.utils.datastructures import SortedDict
 from django.utils.functional import curry
 from django.utils.encoding import smart_str, force_unicode, smart_unicode
 from django.core.files.move import file_move_safe
Index: django/django/db/models/fields/related.py
===================================================================
--- django/django/db/models/fields/related.py	(revision 7999)
+++ django/django/db/models/fields/related.py	(working copy)
@@ -3,10 +3,8 @@
 from django.db.models.fields import AutoField, Field, IntegerField, PositiveIntegerField, PositiveSmallIntegerField, FieldDoesNotExist
 from django.db.models.related import RelatedObject
 from django.db.models.query_utils import QueryWrapper
-from django.utils.text import capfirst
 from django.utils.translation import ugettext_lazy, string_concat, ungettext, ugettext as _
 from django.utils.functional import curry
-from django.utils.encoding import smart_unicode
 from django.core import validators
 from django import oldforms
 from django import forms
Index: django/django/db/models/__init__.py
===================================================================
--- django/django/db/models/__init__.py	(revision 7999)
+++ django/django/db/models/__init__.py	(working copy)
@@ -10,8 +10,6 @@
 from django.db.models.fields.subclassing import SubfieldBase
 from django.db.models.fields.related import ForeignKey, OneToOneField, ManyToManyField, ManyToOneRel, ManyToManyRel, OneToOneRel, TABULAR, STACKED
 from django.db.models import signals
-from django.utils.functional import curry
-from django.utils.text import capfirst
 
 # Admin stages.
 ADD, CHANGE, BOTH = 1, 2, 3
Index: django/django/db/backends/oracle/base.py
===================================================================
--- django/django/db/backends/oracle/base.py	(revision 7999)
+++ django/django/db/backends/oracle/base.py	(working copy)
@@ -8,7 +8,6 @@
 
 from django.db.backends import BaseDatabaseWrapper, BaseDatabaseFeatures, BaseDatabaseOperations, util
 from django.db.backends.oracle import query
-from django.utils.datastructures import SortedDict
 from django.utils.encoding import smart_str, force_unicode
 
 # Oracle takes client-side character set encoding from the environment.
Index: django/django/forms/util.py
===================================================================
--- django/django/forms/util.py	(revision 7999)
+++ django/django/forms/util.py	(working copy)
@@ -1,6 +1,5 @@
 from django.utils.html import escape
 from django.utils.encoding import smart_unicode, StrAndUnicode, force_unicode
-from django.utils.functional import Promise
 from django.utils.safestring import mark_safe
 
 def flatatt(attrs):
Index: django/django/forms/formsets.py
===================================================================
--- django/django/forms/formsets.py	(revision 7999)
+++ django/django/forms/formsets.py	(working copy)
@@ -2,7 +2,7 @@
 from django.utils.encoding import StrAndUnicode
 from django.utils.safestring import mark_safe
 from fields import IntegerField, BooleanField
-from widgets import Media, HiddenInput, TextInput
+from widgets import Media, HiddenInput
 from util import ErrorList, ValidationError
 
 __all__ = ('BaseFormSet', 'all_valid')
Index: django/django/forms/models.py
===================================================================
--- django/django/forms/models.py	(revision 7999)
+++ django/django/forms/models.py	(working copy)
@@ -8,7 +8,6 @@
 from django.utils.translation import ugettext_lazy as _
 from django.utils.encoding import smart_unicode
 from django.utils.datastructures import SortedDict
-from django.core.exceptions import ImproperlyConfigured
 
 from util import ValidationError, ErrorList
 from forms import BaseForm, get_declared_fields
Index: django/django/forms/fields.py
===================================================================
--- django/django/forms/fields.py	(revision 7999)
+++ django/django/forms/fields.py	(working copy)
@@ -23,7 +23,7 @@
     from sets import Set as set
 
 from django.utils.translation import ugettext_lazy as _
-from django.utils.encoding import StrAndUnicode, smart_unicode, smart_str
+from django.utils.encoding import smart_unicode, smart_str
 
 from util import ErrorList, ValidationError
 from widgets import TextInput, PasswordInput, HiddenInput, MultipleHiddenInput, FileInput, CheckboxInput, Select, NullBooleanSelect, SelectMultiple, DateTimeInput
Index: django/django/core/files/uploadhandler.py
===================================================================
--- django/django/core/files/uploadhandler.py	(revision 7999)
+++ django/django/core/files/uploadhandler.py	(working copy)
@@ -1,8 +1,6 @@
 """
 Base file upload handler classes, and the built-in concrete subclasses
 """
-import os
-import tempfile
 try:
     from cStringIO import StringIO
 except ImportError:
Index: django/django/core/management/commands/compilemessages.py
===================================================================
--- django/django/core/management/commands/compilemessages.py	(revision 7999)
+++ django/django/core/management/commands/compilemessages.py	(working copy)
@@ -2,7 +2,6 @@
 import sys
 from optparse import make_option
 from django.core.management.base import BaseCommand
-from django.core.management.color import no_style
 
 try:
     set
Index: django/django/core/management/commands/testserver.py
===================================================================
--- django/django/core/management/commands/testserver.py	(revision 7999)
+++ django/django/core/management/commands/testserver.py	(working copy)
@@ -17,7 +17,6 @@
     requires_model_validation = False
 
     def handle(self, *fixture_labels, **options):
-        from django.conf import settings
         from django.core.management import call_command
         from django.test.utils import create_test_db
 
Index: django/django/core/management/commands/test.py
===================================================================
--- django/django/core/management/commands/test.py	(revision 7999)
+++ django/django/core/management/commands/test.py	(working copy)
@@ -17,7 +17,6 @@
 
     def handle(self, *test_labels, **options):
         from django.conf import settings
-        from django.db.models import get_app, get_apps
 
         verbosity = int(options.get('verbosity', 1))
         interactive = options.get('interactive', True)
Index: django/django/views/generic/simple.py
===================================================================
--- django/django/views/generic/simple.py	(revision 7999)
+++ django/django/views/generic/simple.py	(working copy)
@@ -1,4 +1,3 @@
-from django.shortcuts import render_to_response
 from django.template import loader, RequestContext
 from django.http import HttpResponse, HttpResponsePermanentRedirect, HttpResponseGone
 
Index: django/django/dispatch/saferef.py
===================================================================
--- django/django/dispatch/saferef.py	(revision 7999)
+++ django/django/dispatch/saferef.py	(working copy)
@@ -1,6 +1,5 @@
 """Refactored "safe reference" from dispatcher.py"""
 import weakref, traceback
-from django.utils.functional import curry
 
 def safeRef(target, onDelete = None):
     """Return a *safe* weak reference to a callable target
Index: django/django/dispatch/dispatcher.py
===================================================================
--- django/django/dispatch/dispatcher.py	(revision 7999)
+++ django/django/dispatch/dispatcher.py	(working copy)
@@ -25,7 +25,7 @@
         deletion, (considerably speeds up the cleanup process
         vs. the original code.)
 """
-import types, weakref
+import weakref
 from django.dispatch import saferef, robustapply, errors
 
 __author__ = "Patrick K. O'Brien <pobrien@orbtech.com>"
Index: django/django/contrib/formtools/tests.py
===================================================================
--- django/django/contrib/formtools/tests.py	(revision 7999)
+++ django/django/contrib/formtools/tests.py	(working copy)
@@ -1,7 +1,6 @@
 from django import forms
 from django.contrib.formtools import preview
 from django import http
-from django.conf import settings
 from django.test import TestCase
 
 success_string = "Done was called!"
Index: django/django/contrib/syndication/feeds.py
===================================================================
--- django/django/contrib/syndication/feeds.py	(revision 7999)
+++ django/django/contrib/syndication/feeds.py	(working copy)
@@ -1,5 +1,5 @@
 from django.core.exceptions import ImproperlyConfigured, ObjectDoesNotExist
-from django.template import Context, loader, Template, TemplateDoesNotExist
+from django.template import loader, Template, TemplateDoesNotExist
 from django.contrib.sites.models import Site, RequestSite
 from django.utils import feedgenerator
 from django.utils.encoding import smart_unicode, iri_to_uri
Index: django/django/contrib/admin/views/main.py
===================================================================
--- django/django/contrib/admin/views/main.py	(revision 7999)
+++ django/django/contrib/admin/views/main.py	(working copy)
@@ -6,7 +6,6 @@
 from django.db.models.query import QuerySet
 from django.utils.encoding import force_unicode, smart_str
 from django.utils.translation import ugettext
-from django.utils.safestring import mark_safe
 from django.utils.http import urlencode
 import operator
 
Index: django/django/contrib/databrowse/plugins/calendars.py
===================================================================
--- django/django/contrib/databrowse/plugins/calendars.py	(revision 7999)
+++ django/django/contrib/databrowse/plugins/calendars.py	(working copy)
@@ -4,7 +4,6 @@
 from django.contrib.databrowse.sites import DatabrowsePlugin
 from django.shortcuts import render_to_response
 from django.utils.text import capfirst
-from django.utils.translation import get_date_formats
 from django.utils.encoding import force_unicode
 from django.utils.safestring import mark_safe
 from django.views.generic import date_based
Index: django/django/contrib/databrowse/plugins/fieldchoices.py
===================================================================
--- django/django/contrib/databrowse/plugins/fieldchoices.py	(revision 7999)
+++ django/django/contrib/databrowse/plugins/fieldchoices.py	(working copy)
@@ -6,7 +6,6 @@
 from django.utils.text import capfirst
 from django.utils.encoding import smart_str, force_unicode
 from django.utils.safestring import mark_safe
-from django.views.generic import date_based
 import urllib
 
 class FieldChoicePlugin(DatabrowsePlugin):
Index: django/django/contrib/databrowse/views.py
===================================================================
--- django/django/contrib/databrowse/views.py	(revision 7999)
+++ django/django/contrib/databrowse/views.py	(working copy)
@@ -1,7 +1,5 @@
-from django.db.models import FieldDoesNotExist, DateTimeField
 from django.http import Http404
 from django.shortcuts import render_to_response
-from django.contrib.databrowse.datastructures import EasyModel, EasyChoice
 
 ###########
 # CHOICES #
Index: django/django/contrib/databrowse/sites.py
===================================================================
--- django/django/contrib/databrowse/sites.py	(revision 7999)
+++ django/django/contrib/databrowse/sites.py	(working copy)
@@ -1,6 +1,6 @@
 from django import http
 from django.db import models
-from django.contrib.databrowse.datastructures import EasyModel, EasyChoice
+from django.contrib.databrowse.datastructures import EasyModel
 from django.shortcuts import render_to_response
 from django.utils.safestring import mark_safe
 
Index: django/django/contrib/auth/decorators.py
===================================================================
--- django/django/contrib/auth/decorators.py	(revision 7999)
+++ django/django/contrib/auth/decorators.py	(working copy)
@@ -1,7 +1,7 @@
 try:
     from functools import wraps, update_wrapper
 except ImportError:
-    from django.utils.functional import wraps, update_wrapper  # Python 2.3, 2.4 fallback.
+    from django.utils.functional import update_wrapper  # Python 2.3, 2.4 fallback.
 
 from django.contrib.auth import REDIRECT_FIELD_NAME
 from django.http import HttpResponseRedirect
Index: django/django/contrib/auth/forms.py
===================================================================
--- django/django/contrib/auth/forms.py	(revision 7999)
+++ django/django/contrib/auth/forms.py	(working copy)
@@ -2,7 +2,6 @@
 from django.contrib.auth import authenticate
 from django.contrib.sites.models import Site
 from django.template import Context, loader
-from django.core import validators
 from django import forms
 from django.utils.translation import ugettext_lazy as _
 
Index: django/django/contrib/admindocs/views.py
===================================================================
--- django/django/contrib/admindocs/views.py	(revision 7999)
+++ django/django/contrib/admindocs/views.py	(working copy)
@@ -5,7 +5,7 @@
 from django.db import models
 from django.shortcuts import render_to_response
 from django.core.exceptions import ImproperlyConfigured, ViewDoesNotExist
-from django.http import Http404, get_host
+from django.http import Http404
 from django.core import urlresolvers
 from django.contrib.admindocs import utils
 from django.contrib.sites.models import Site
Index: django/django/contrib/sessions/backends/cache.py
===================================================================
--- django/django/contrib/sessions/backends/cache.py	(revision 7999)
+++ django/django/contrib/sessions/backends/cache.py	(working copy)
@@ -1,4 +1,3 @@
-from django.conf import settings
 from django.contrib.sessions.backends.base import SessionBase
 from django.core.cache import cache
 
Index: django/django/contrib/sessions/backends/db.py
===================================================================
--- django/django/contrib/sessions/backends/db.py	(revision 7999)
+++ django/django/contrib/sessions/backends/db.py	(working copy)
@@ -1,6 +1,5 @@
 import datetime
 
-from django.conf import settings
 from django.contrib.sessions.models import Session
 from django.contrib.sessions.backends.base import SessionBase
 from django.core.exceptions import SuspiciousOperation
Index: django/django/utils/dateformat.py
===================================================================
--- django/django/utils/dateformat.py	(revision 7999)
+++ django/django/utils/dateformat.py	(working copy)
@@ -13,7 +13,7 @@
 
 from django.utils.dates import MONTHS, MONTHS_3, MONTHS_AP, WEEKDAYS, WEEKDAYS_ABBR
 from django.utils.tzinfo import LocalTimezone
-from django.utils.translation import string_concat, ugettext as _
+from django.utils.translation import ugettext as _
 from django.utils.encoding import force_unicode
 from calendar import isleap, monthrange
 import re, time
Index: django/django/utils/encoding.py
===================================================================
--- django/django/utils/encoding.py	(revision 7999)
+++ django/django/utils/encoding.py	(working copy)
@@ -3,7 +3,6 @@
 import datetime
 
 from django.utils.functional import Promise
-from django.utils.safestring import SafeData, mark_safe
 
 class DjangoUnicodeDecodeError(UnicodeDecodeError):
     def __init__(self, obj, *args):
Index: django/django/contrib/auth/management/commands/createsuperuser.py
===================================================================
--- django/django/contrib/auth/management/commands/createsuperuser.py	(revision 8002)
+++ django/django/contrib/auth/management/commands/createsuperuser.py	(working copy)
@@ -7,7 +7,7 @@
 import re
 import sys
 from optparse import make_option
-from django.contrib.auth.models import User, UNUSABLE_PASSWORD
+from django.contrib.auth.models import User
 from django.core import validators
 from django.core.management.base import BaseCommand, CommandError
 
Index: django/django/contrib/admin/options.py
===================================================================
--- django/django/contrib/admin/options.py	(revision 8002)
+++ django/django/contrib/admin/options.py	(working copy)
@@ -1,4 +1,4 @@
-from django import oldforms, template
+from django import template
 from django import forms
 from django.forms.formsets import all_valid
 from django.forms.models import modelform_factory, inlineformset_factory
Index: django/django/contrib/admin/widgets.py
===================================================================
--- django/django/contrib/admin/widgets.py	(revision 8002)
+++ django/django/contrib/admin/widgets.py	(working copy)
@@ -7,8 +7,7 @@
 from django import forms
 from django.forms.widgets import RadioFieldRenderer
 from django.forms.util import flatatt
-from django.utils.datastructures import MultiValueDict
-from django.utils.text import capfirst, truncate_words
+from django.utils.text import truncate_words
 from django.utils.translation import ugettext as _
 from django.utils.safestring import mark_safe
 from django.utils.encoding import force_unicode
Index: django/django/contrib/auth/admin.py
===================================================================
--- django/django/contrib/auth/admin.py	(revision 8002)
+++ django/django/contrib/auth/admin.py	(working copy)
@@ -1,6 +1,6 @@
 from django.contrib.auth.models import User, Group
 from django.core.exceptions import PermissionDenied
-from django import oldforms, template
+from django import template
 from django.shortcuts import render_to_response
 from django.http import HttpResponseRedirect
 from django.utils.translation import ugettext, ugettext_lazy as _